import { FC } from 'react';
interface RegisteredComponents {
    [key: string]: Promise<any>;
}
interface Props {
    [key: string]: string;
}
interface HTMLElementAttributes {
    [key: string]: string;
}
interface PopulateOptions {
    attributes?: HTMLElementAttributes;
    callback?: Function;
}
export declare type RegisterPromise = () => Promise<any>;
export declare type RegisterComponent = () => FC<any>;
export declare type RegisterFN = RegisterPromise | RegisterComponent;
export declare let componentSelector: string;
export declare let components: RegisteredComponents;
export declare let unPopulatedElements: Element[];
export declare const register: (name: string, fn: RegisterFN) => void;
export declare const unRegisterAllComponents: () => void;
export declare const delay: (ms: number) => Promise<unknown>;
export declare const setComponentSelector: (selector: string) => void;
export declare const getRegisteredComponents: () => RegisteredComponents;
export declare const getActiveComponents: () => (string | null)[];
export declare const getCleanPropName: (raw: string) => string;
export declare const getElementProps: (el: Element | HTMLScriptElement) => Props;
export declare const getScriptProps: () => Props;
export declare const getAbodeElements: () => Element[];
export declare const setUnpopulatedElements: () => void;
export declare const setAttributes: (el: Element, attributes: HTMLElementAttributes) => void;
export declare const renderAbode: (el: Element) => Promise<void>;
export declare const trackPropChanges: (el: Element) => void;
export declare const update: (elements: Element[], options?: PopulateOptions | undefined) => Promise<void>;
export declare const populate: (options?: PopulateOptions | undefined) => Promise<void>;
export {};
